# Copyright (c) 2000-2011, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_without repolib

%define repodir %{_javadir}/repository.jboss.com/jboss/cache/jbosscache-core/%{version}.%{reltag}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

%define section free
%define reltag GA
%define namedversion %{version}.%{reltag}

Name:           jboss-cache-core
Version:        3.1.0
Release:        10%{?dist}
Epoch:          0
Summary:        JBoss Cache Core
License:        LGPLv2+
Group:          Development/Java
URL:            http://www.jboss.org/
# svn -q export http://anonsvn.jboss.org/repos/jbosscache/core/tags/3.1.0.GA/ jboss-cache-core-3.1.0
Source0:        jboss-cache-core-3.1.0.tar.gz
Source1:        jboss-cache-core-jpp-depmap.xml
Source3:        jboss-cache-core-component-info.xml
Patch0:         jboss-cache-core-pom.patch
Patch1:         jboss-cache-core-assembly-src.patch
# https://source.jboss.org/rdiff/JBossCache/core/trunk/src/main/java/org/jboss/cache/eviction/ExpirationAlgorithm.java?r1=7168&r2=8362&u&N
Patch2:		ExpirationAlgorithm.java.patch
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       java >= 0:1.5.0
Requires:       jpackage-utils
Requires:       commons-logging >= 0:1.1.1
Requires:       jta_1_1_api
Requires:       jgroups >= 0:2.6.7
Requires:       jboss-common-core >= 0:2.2.10
Requires:       jbosscache-support >= 0:1.5
# Optional
%if 0
Requires:       jdbm >= 0:1.0
Requires:       c3p0 >= 0:0.9.1.2
Requires:       berkeleydb-je33 >= 0:3.3.75
Requires:       jcip-annotations >= 0:1.0
Requires:       noderunner-amazon-s3 >= 1.0.0.0
%endif
BuildRequires:  maven-surefire-provider-junit4
BuildRequires:  maven-shared-filtering
BuildRequires:  commons-parent
BuildRequires:  jboss-parent >= 0:4
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-eclipse
BuildRequires:  maven2-plugin-enforcer
BuildRequires:  maven2-plugin-idea
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-source
BuildRequires:  jbosscache-support >= 0:1.5
BuildRequires:  c3p0 >= 0:0.9.1.2
BuildRequires:  commons-logging >= 0:1.1.1
BuildRequires:  berkeleydb-je33 >= 0:3.3.75
BuildRequires:  hsqldb >= 1.8.0.7
BuildRequires:  servlet_2_5_api
BuildRequires:  jta_1_1_api
BuildRequires:  jbossts >= 0:4.4.0
BuildRequires:  jdbm >= 0:1.0
BuildRequires:  jgroups >= 0:2.6.7
BuildRequires:  junit4 >= 0:4.8.2
BuildRequires:  jcip-annotations >= 0:1.0
BuildRequires:  noderunner-amazon-s3 >= 1.0.0.0
BuildRequires:  bsh2 >= 0:2.0
BuildRequires:  easymock2 >= 0:2.4
BuildRequires:  jboss-common-core >= 0:2.2.10
BuildRequires:  testng >= 0:6.1.1
BuildRequires:  maven2-plugin-assembly
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-surefire
BuildRequires:	maven-enforcer-plugin
BuildRequires:  java-devel >= 0:1.5.0
BuildRequires:  jpackage-utils
BuildRequires:  oss-parent >= 0:3
BuildRequires:  maven-surefire-provider-testng >= 0:2.4.3
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
JBoss cache core.

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation
Requires:       jpackage-utils

%description javadoc
%{summary}.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%setup -q 
%patch0 -p1 -b .sav0
%patch1 -p1 -b .sav1
%patch2 -p2 -b .sav2

%build
export MAVEN_REPO_LOCAL=`pwd`/m2_repo/repository
%{_bindir}/mvn-jpp -e \
        -Dmaven.repo.local=${MAVEN_REPO_LOCAL} \
        -Dmaven2.jpp.depmap.file=%{SOURCE1} \
        -Dmaven.test.failure.ignore=true \
        -DskipTests=true \
        install javadoc:aggregate

%install
rm -rf %{buildroot}

# jars
install -d -m 755 %{buildroot}%{_javadir}
install -p -m 644 target/jbosscache-core.jar %{buildroot}%{_javadir}/%{name}-%{version}.jar
install -p -m 644 target/jbosscache-core-tests.jar %{buildroot}%{_javadir}/%{name}-tests-%{version}.jar
ln -s %{name}-%{version}.jar %{buildroot}%{_javadir}/jbosscache-core-%{version}.jar
ln -s %{name}-tests-%{version}.jar %{buildroot}%{_javadir}/jbosscache-core-tests-%{version}.jar
(cd %{buildroot}%{_javadir} && for jar in *-%{version}*; do ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`; done)

# pom
install -d -m 755 %{buildroot}%{_datadir}/maven2/poms
install -p -m 644 pom.xml %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}.pom
%add_to_maven_depmap org.jboss.cache jbosscache-core %{namedversion} JPP %{name}

# javadoc
install -d -m 755 %{buildroot}%{_javadocdir}/%{name}-%{version}
cp -pr target/site/apidocs/* %{buildroot}%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} %{buildroot}%{_javadocdir}/%{name}
ln -s %{name}-%{version} %{buildroot}%{_javadocdir}/jbosscache-core-%{version}
ln -s jbosscache-core-%{version} %{buildroot}%{_javadocdir}/jbosscache-core

%if %with repolib
install -d -m 755 %{buildroot}%{repodir}
install -d -m 755 %{buildroot}%{repodirlib}
install -p -m 644 %{SOURCE3} %{buildroot}%{repodir}/component-info.xml
sed -i 's/@VERSION@/%{version}.%{reltag}-brew/g' %{buildroot}%{repodir}/component-info.xml
tag=`echo %{name}-%{version}-%{release} | sed 's|\.|_|g'`
sed -i "s/@TAG@/$tag/g" %{buildroot}%{repodir}/component-info.xml
install -d -m 755 %{buildroot}%{repodirsrc}
install -p -m 644 %{SOURCE0} %{buildroot}%{repodirsrc}
install -p -m 644 %{SOURCE1} %{buildroot}%{repodirsrc}
install -p -m 644 %{PATCH0} %{buildroot}%{repodirsrc}
install -p -m 644 %{PATCH1} %{buildroot}%{repodirsrc}
install -p -m 644 %{PATCH2} %{buildroot}%{repodirsrc}
cp -p %{buildroot}%{_javadir}/%{name}-%{version}.jar %{buildroot}%{repodirlib}/jbosscache-core.jar
cp -p %{buildroot}%{_datadir}/maven2/poms/JPP-%{name}.pom %{buildroot}%{repodirlib}/jbosscache-core.pom
%endif

%clean
rm -rf %{buildroot}

%post
%update_maven_depmap

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%{_javadir}/jboss-cache-core-%{version}.jar
%{_javadir}/jboss-cache-core-tests-%{version}.jar
%{_javadir}/jboss-cache-core-tests.jar
%{_javadir}/jboss-cache-core.jar
%{_javadir}/jbosscache-core-%{version}.jar
%{_javadir}/jbosscache-core-tests-%{version}.jar
%{_javadir}/jbosscache-core-tests.jar
%{_javadir}/jbosscache-core.jar
%{_datadir}/maven2/poms/JPP-%{name}.pom
%{_mavendepmapfragdir}/%{name}

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}
%{_javadocdir}/jbosscache-core-%{version}
%{_javadocdir}/jbosscache-core

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}
%{_javadir}/repository.jboss.com
%endif

%changelog
* Wed May 23 2012 David Walluck <dwalluck@redhat.com> 0:3.1.0-10
- clean up maven options
- fix testng dependency by removing classifier portion (-jdk15)
- BuildRequires: oss-parent >= 0:3
- BuildRequires: maven-surefire-provider-testng >= 0:2.4.3
- skip tests (they require network and seem to stall)

* Wed May 23 2012 Will Tatam <will.tatam@red61.com> 0:3.1.0-9
- Include patch for https://issues.jboss.org/browse/JBCACHE-1574

* Sat Feb 12 2011 David Walluck <dwalluck@redhat.com> 0:3.1.0-8
- don't Requires optional dependencies

* Thu Feb 10 2011 David Walluck <dwalluck@redhat.com> 0:3.1.0-7
- Requires: jbosscache-support >= 0:1.5

* Thu Feb 10 2011 David Walluck <dwalluck@redhat.com> 0:3.1.0-6
- rebuild for jbosscache-support

* Tue Jan 18 2011 David Walluck <dwalluck@redhat.com> 0:3.1.0-5
- fix pom install location prior to build
- patch poms for maven2 bug
- fix file list
- install pom to repolib

* Sat Jan 09 2010 Will Tatam <will.tatam@red61.com> 3.1.0-4
- Auto rebuild for JPackage 6 in centos5 mock
- BuildRequires: commons-parent

* Wed Jul 01 2009 David Walluck <dwalluck@redhat.com> 0:3.1.0-3
- fix repolib

* Tue Jun 30 2009 David Walluck <dwalluck@redhat.com> 0:3.1.0-2
- add repolib
- add compat symlinks

* Mon Jun 29 2009 Ralph Apel <r.apel@r-apel.de> - 0:3.1.0-1.jpp5
- 3.1.0.GA

* Mon Jun 15 2009 Ralph Apel <r.apel@r-apel.de> - 0:2.2.0-1.jpp5
- first release
